package com.securitycontrol.system.api.factory;

import com.securitycontrol.system.api.domain.SysLog;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;
import com.securitycontrol.common.core.domain.Result;
import com.securitycontrol.system.api.RemoteLogService;
import com.securitycontrol.system.api.domain.SysLogininfor;
import com.securitycontrol.system.api.domain.SysOperLog;

/**
 * 日志服务降级处理
 *
 * @author czc
 */
@Component
public class RemoteLogFallbackFactory implements FallbackFactory<RemoteLogService>
{
    private static final Logger log = LoggerFactory.getLogger(RemoteLogFallbackFactory.class);

    @Override
    public RemoteLogService create(Throwable throwable)
    {
        log.error("日志服务调用失败:{}", throwable.getMessage());
        return new RemoteLogService()
        {
            @Override
            public Result<Boolean> saveLogs(SysOperLog sysOperLog, String source)
            {
                return Result.fail("日志服务调用失败:" + throwable.getMessage());
            }

            @Override
            public Result<Boolean> saveLogininfor(SysLogininfor sysLogininfor, String source)
            {
                return Result.fail("日志服务调用失败:" + throwable.getMessage());
            }

            @Override
            public Result<Boolean> saveSysLog(SysLog sysLog, String source) {
                return Result.fail("日志服务调用失败:" + throwable.getMessage());
            }
        };

    }
}
